clear all
set more off
set maxvar 10000
set mem 500m
cap log close
pause on

*cd "C:\Documents and Settings\qeh\My Documents\Teachings\Summer School OPHI - Delft2011\Exercise3"
cd "C:\Users\Adri\Desktop\FA\Ejercicios y materiales\Ejercicios"

use "2. OPHI-HDCA SS11 - Working Groups on Principal Components and Factor Analyses, data 2009_v3, JMR.dta", clear

log using exercise3.log, replace


* We only keep the household head (one observation per household) - r01: relationship
drop if r01!=1


**** Change the lenguage of the dictionary

label language 
label language english

save "C:\Documents and Settings\qeh\My Documents\Teachings\Summer School OPHI - Delft2011\Exercise3\OPHI2009_exercise3.dta", replace


*** 1. Explore the original variables with descriptive statistics

codebook mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c

* Dont know and no response is codified as 99 and should be missing value
foreach var in mv1 mv2_a mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c {
replace `var'=.a if `var'==99
replace `var'=.b if `var'==88
}

codebook mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c


* Explore the correlations
ktau	 mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c, stats(taub)


*** 2. Run a Exploratory Factor Analysis with the 12 variables and discuss: Do the scales measure the theoretical construct?

* Convergent validation and discriminatory power of the items within factors
factor	 mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c [weight = factor], pf

scree

* to install the following command: findit fapara (http://www.ats.ucla.edu/stat/stata/faq/parallel.htm)
fapara, reps(10)
factor	mv3_a mv3_b mv3_c mv4_a mv4_b mv4_c mv5_a mv5_b mv5_c mv6_a mv6_b mv6_c [weight= factor], factor(4)
rotate, promax blank(0.1)

*** => They converge were they should!


*** 3. Generate the Alpha Cronbach coefficient to assess the internal consistency of the scales. Check internal consistency
alpha mv3_a mv3_b mv3_c, std item 
alpha mv4_a mv4_b mv4_c, std item 
alpha mv5_a mv5_b mv5_c, std item 
alpha mv6_a mv6_b mv6_c, std item


*** 4. Confirmatory Factor Analysis to evaluate the theoretical constructs: Hipothesis test for the theoretical model 
* to install the following command: findit confa
confa (mea: mv3_a mv3_b mv3_c) (aut: mv4_a mv4_b mv4_c) (com: mv5_a mv5_b mv5_c) (rel: mv6_a mv6_b mv6_c), unitvar(meaning_a autonomy_a compentence_a relatedness_a) from(2sls) 
estat fit
estat corr

* Convergent validation and internal consistency
alpha mv3_a mv3_b mv3_c, generate(meaning)  
alpha mv4_a mv4_b mv4_c, generate(autonomy)  
alpha mv5_a mv5_b mv5_c, generate(relatedness)  
alpha mv6_a mv6_b mv6_c, generate(competence)  


log close
